# DEMO 1

megnyitott_projekt = QgsProject.instance()
uzenetsor = iface.messageBar()
retegnevek = ["kozeptajak", "nincs ilyen", "magyarorszag"]
for retegnev in retegnevek:
	uzenetsor.pushMessage(
		title = "Centroidképzés kezdete",
		text = "A(z) " + retegnev + " nevű rétegre a centroidképzés megkezdődött.",
		level = Qgis.MessageLevel.Info, # vagy: level = 0
		duration = 2 # 2 másodperc múlva bezáródik
	)
	retegek = megnyitott_projekt.mapLayersByName(layerName = retegnev)
	if len(retegek) > 0:
		reteg = retegek[0]
		if len(retegek) > 1:
			uzenetsor.pushMessage(
				title = "Centroidképzés probléma",
				text = "A(z) " + retegnev + " néven több réteget is találtam, az elsőt fogom használni.",
				level = Qgis.MessageLevel.Warning, # vagy: level = 1
				duration = -1 # alapértelmezett ideig jelenjen meg
			)
		centroid_eredmeny = processing.runAndLoadResults(
			algOrName = "native:centroids",
			parameters = {
				"INPUT": reteg,
				"ALL_PARTS": True,
				"OUTPUT": "TEMPORARY_OUTPUT"
			}
		)
		uzenetsor.pushMessage(
			title = "Centroidképzés vége",
			text = "A(z) " + retegnev + " nevű réteg centroidjait elkészítettem.",
			level = Qgis.MessageLevel.Success, # vagy: level = 3
			duration = 0 # végtelen ideig jelenjen meg
		)
	else: # ha nem volt ilyen nevű réteg
		uzenetsor.pushMessage(
			title = "Centroidképzés vége",
			text = "A(z) " + retegnev + " nevű réteget nem találtam, a centroidképzés meghiúsult.",
			level = Qgis.MessageLevel.Critical, # vagy: level = 2
			duration = 0 # végtelen ideig jelenjen meg
		)


# DEMO 2

from time import sleep as varakozz
uzenetsor.pushInfo(title = "Információ", message = "A demó elkezdődött.")
iface.mainWindow().repaint()
varakozz(1)
uzenetsor.clearWidgets()

uzenetsor.pushWarning(title = "Figyelmeztetés", message = "Valami nem biztos, hogy jó.")
iface.mainWindow().repaint()
varakozz(3)
uzenetsor.pushCritical(title = "Hiba", message = "Komoly hibát találtam.")
iface.mainWindow().repaint()
varakozz(3)
uzenetsor.pushSuccess(title = "Siker", message = "De sikerült kijavítanom.")
iface.mainWindow().repaint()


# Feladat

import time
kozeptajak = megnyitott_projekt.mapLayersByName(layerName = "kozeptajak")[0]
if len(kozeptajak.selectedFeatures()) == 0:
	uzenetsor.pushMessage(
		title = "Hiba",
		text = "A(z) " + kozeptajak.name() + " nevű rétegen nincs kijelölés.",
		level = Qgis.MessageLevel.Critical,
		duration = 2
	)
else:
	kozeptajak.removeSelection()
	uzenetsor.pushMessage(
		title = "Siker",
		text = "A(z) " + kozeptajak.name() + " nevű rétegen megszüntettem a kijelölést.",
		level = Qgis.MessageLevel.Success,
		duration = 0
	)
	iface.mainWindow().repaint()
	time.sleep(2)
	uzenetsor.clearWidgets()


# DEMO 3

# 1. verzió, for+break használata (nem szeretjük...)
for eszkoz in QgsApplication.processingRegistry().algorithms():
	if eszkoz.id() == "native:centroids":
		break # megállitja a ciklus futását (még mielőtt a végére érne)

centroidkepzo_eszkoz = eszkoz # a ciklusváltozó utolsó értéke

# 2. verzió: while használata (körülményesebb, de szeretjük)
megtalaltam = False
osszes_eszkoz = QgsApplication.processingRegistry().algorithms()
lepteto = 0
while (not megtalaltam):
	megtalaltam = osszes_eszkoz[lepteto].id() == "native:centroids"
	lepteto = lepteto + 1

centroidkepzo_eszkoz = eszkoz # a ciklusváltozó utolsó értéke

type(centroidkepzo_eszkoz) # QgsProcessingFeatureBasedAlgorithm
dir(centroidkepzo_eszkoz)
centroidkepzo_eszkoz.id()
centroidkepzo_eszkoz.name()
centroidkepzo_eszkoz.displayName()
centroidkepzo_eszkoz.groupId()
centroidkepzo_eszkoz.group()
centroidkepzo_eszkoz.shortHelpString()



