# -*- coding: utf-8 -*-

from qgis.PyQt.QtCore import QCoreApplication
from qgis.core import QgsProcessing, QgsFeatureSink, QgsProcessingException, QgsProcessingAlgorithm, QgsProcessingParameterVectorLayer, QgsProcessingParameterVectorDestination # itt még hozzá kell adni a szükséges típusokat
from qgis import processing

class sabloneszkoz(QgsProcessingAlgorithm):
	INPUT = "INPUT" # a bemeneti paraméter neve
	OUTPUT = "OUTPUT" # a kimeneti paraméter neve

	def tr(self, forditando_szoveg):
		return QCoreApplication.translate("Processing", forditando_szoveg)

	def createInstance(self):
		return sabloneszkoz() # itt kell másodszor módosítani az eszköz nevét

	def name(self):
		return "elso_eszkoz"

	def displayName(self):
		return self.tr("Első szkripteszközöm (pufferképzés)")

	def group(self):
		return self.tr("Saját eszközcsoport")

	def groupId(self):
		return "sajat_eszkozcsoport"

	def shortHelpString(self):
		return self.tr("Ez egy olyan eszköz, ami még semmi értelmeset nem csinál, de azért hasznos nézegetni a forráskódját.")

	def initAlgorithm(self, config = None):
		self.addParameter( # paraméter hozzáadása
			QgsProcessingParameterVectorLayer( # bemeneti paraméter
				name = self.INPUT,
				description = self.tr("Bemeneti réteg"),
				types = [QgsProcessing.TypeVectorAnyGeometry]
			)
		)
		self.addParameter( # paraméter hozzáadása
			QgsProcessingParameterVectorDestination( # kimeneti paraméter
				name = self.OUTPUT,
				description = self.tr("Kimeneti réteg")
			)
		)

	def processAlgorithm(self, parameters, context, feedback):
		feedback.pushInfo("Pufferképzés megkezdődött.")
		if feedback.isCanceled():
			return {}
		pufferkepzes_eredmenye = processing.run(
			algOrName = "native:buffer",
			parameters = {
				"INPUT": parameters[self.INPUT],
				"DISTANCE": 10000,
				"DISSOLVE": False,
				"OUTPUT": parameters[self.OUTPUT]
			}, 
			is_child_algorithm = True,
			context = context,
			feedback = feedback)
		if feedback.isCanceled():
			return {}
		feedback.pushInfo("Pufferképzés véget ért.")

		return {self.OUTPUT: pufferkepzes_eredmenye["OUTPUT"]}
